library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity cf_shifter is
	port (
		i_data : in std_ulogic_vector(31 downto 0);
		i_count : in std_ulogic_vector(4 downto 0);
		o_left_logic_q : out std_ulogic_vector(31 downto 0);
		o_right_logic_q : out std_ulogic_vector(31 downto 0);
		o_right_arith_q : out std_ulogic_vector(31 downto 0)
	);
end entity; -- cf_shifter

architecture arch of cf_shifter is
begin
	
	process (all)
		variable v_count : natural;
	begin
		v_count := to_integer(unsigned(i_count));
		o_left_logic_q <= std_ulogic_vector(shift_left(unsigned(i_data), v_count));
		o_right_logic_q <= std_ulogic_vector(shift_right(unsigned(i_data), v_count));
		o_right_arith_q <= std_ulogic_vector(shift_right(signed(i_data), v_count));
	end process;
	
end architecture;